Attribute VB_Name = "mdlSymbols"
' Dieser Source stammt von http://www.activevb.de
' und kann frei verwendet werden. Fr eventuelle Schden
' wird nicht gehaftet.
'
' Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
' Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit

' API-Funktionen
Public Declare Function UnDecorateSymbolName Lib "dbghelp.dll" ( _
                 ByVal DecoratedName As String, _
                 ByVal UnDecoratedName As String, _
                 ByVal UndecoratedLength As Long, _
                 ByVal Flags As Long) As Long
                 
Public Declare Function SymInitialize Lib "dbghelp.dll" ( _
                 ByVal hProcess As Long, _
                 ByVal UserSearchPath As String, _
                 ByVal fInvadeProcess As Long) As Long
                 
Public Declare Function SymSetOptions Lib "dbghelp.dll" ( _
                 ByVal SymOptions As Long) As Long
                 
Public Declare Function GetCurrentProcess Lib "kernel32.dll" () As Long

' Konstanten
Global Const SYMOPT_UNDNAME        As Long = &H2
Global Const SYMOPT_DEFERRED_LOADS As Long = &H4

' Vorherige Optionen
Private PrevOptions As Long
                 

' Handler initialisieren
Public Sub Initialize()
   Dim hProcess   As Long  ' Unser Prozess

   ' Optionen setzen und alte Einstellungen sichern
   PrevOptions = SymSetOptions(SYMOPT_UNDNAME Or SYMOPT_DEFERRED_LOADS)

   ' Unseren Prozesshandle abfragen
   hProcess = GetCurrentProcess()

   ' Symbolhandler initialisieren
   Call SymInitialize(hProcess, 0&, 1)
End Sub

' Vorherige Optionen wiederherstellen
Public Sub Shutdown()
   Call SymSetOptions(PrevOptions)
End Sub

' Symbolnamen dekodieren
Function DecodeSymbolName(ByVal DecoratedSymbolName As String, ByRef Buffer As String) As Boolean
   Dim RetVal     As Long  ' Ergebnis der Funktion

   Buffer = Space(1024)    ' Speicher reservieren

   ' Funktion aufrufen (Referenz!)
   RetVal = UnDecorateSymbolName(DecoratedSymbolName, Buffer, 1024, 0&)
   
   ' Status der Funktion
   DecodeSymbolName = (RetVal <> 0)
End Function
